/*
 * @(#)CivLog.java
 * Spec of CivLog File: With an extension name .log
 *                      Start at 1st byte with the string "#FREECIV SCORELOG" 17 chars
 *                      No extra \n\r between line
 *                      int used for year and values data
 *
 *
 * Created on July 23, 2000, 4:26 PM
 */
 
/** 
 *
 * @author  furyhawk
 * @version 0.02
 */

/**
   ********************************************************************
 CivLog - Copyright (C) 2000 - Wong Teck Meng
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
**********************************************************************
                                                                      */
//package CivLog;

//import CivLogFrame;

import javax.swing.*;
import java.awt.*;

public class CivLog extends Object {

  //////////////////////////////////////////////////////////////////////////////////////////////
  // CONSTANTS
  //////////////////////////////////////////////////////////////////////////////////////////////
  
  /** Current CivLog's release. */
  public static final String RELEASE = "0.02ME";
 
  /** Last CivLog's build date. */
  public static final String BUILD = "00.00.01.00";
  
  /** Program name */
  public static final String PROGRAMNAME = "CivLog ";
  
  /** Rmail comments and patches to */
  public static final String EMAIL = "lookmeow@magix.com.sg";

  /** If true, CivLog will delete user settings if this release is newer */
  //public static final boolean DELETE_OLD_SETTINGS = false;

  /** Available new lines characters */
  public static final String[] NEW_LINE = { "\r", "\n", "\r\n" };
  
  /** Settings directory. */
  /*public static final String SETTINGS_DIRECTORY = System.getProperty("user.home") +
                                                  File.separator + ".log" + File.separator;*/
  /** CivLog home directory. */
  /*public static final String CIVLOG_HOME = System.getProperty("user.dir");*/

  /** Creates new CivLog */
  public CivLog() {
    /** TODO: What????? */
  }
  
  /**
   * @param args the command line arguments
   */
  public static void main (String args[]) {
    ///////////////////////////////// DEBUG
    //// System.setErr(System.out);

    System.out.println ( PROGRAMNAME + RELEASE + " initializing...");
    Debug.trace ("Java version:"+System.getProperty ("java.version"));
    Debug.trace ("OS Name:"+System.getProperty ("os.name"));
    Debug.trace ("OS version:"+System.getProperty ("os.version"));
    Debug.trace ("OS arch:"+System.getProperty ("os.arch"));
    Debug.trace ( "main: Max Short Size: " + Short.MAX_VALUE );
    Debug.trace ( "main: Max Integer Size: " + Integer.MAX_VALUE );
    Debug.trace ( "main: Max Long Size: " + Long.MAX_VALUE );
    Debug.trace ( "main: Max Float Size: " + Float.MAX_VALUE );
    
    /*if (args.length > 0)
    {
      File file = new File (args[0]);
      if (file.getName ().endsWith (".java") || file.getName ().endsWith (
      ".html") || file.getName ().endsWith ("htm"))
      window.loadChild (file.getName (), file);
      if (file.getName ().endsWith (".prj"))
      window.project.OpenNewProject (file);
    }*/

    JFrame mainFrame = new CivLogFrame();
    mainFrame.setSize(new Dimension(900,600));
    mainFrame.setTitle (PROGRAMNAME + RELEASE);
    Debug.trace( "main: Attempting to load main frame" );
    //mainFrame.pack();
    SwingUtil.centerWindow( mainFrame );
    mainFrame.show ();
    
    Debug.trace("main: CivLog main thread exiting.");
  }

  
}
// End of CivLog.java