/*
 * @(#)CivLogDraw.java - responsible for draw the graph
 * needs to be optimized a lot
 *
 * Created on July 23, 2000, 4:37 PM
 */

/**
 *
 * @author  furyhawk
 * @version 0.10
 */

/**
   ********************************************************************
 CivLog - Copyright (C) 2000 - Wong Teck Meng
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
**********************************************************************
                                                                      */

//package CivLogDraw;

import java.awt.*;
import java.awt.event.*;

import java.util.Vector;

import javax.swing.*;

public class CivLogDraw extends javax.swing.JPanel {

  public static int currentData = -1;
  int startYear, endYear;
  int currentTurnRange; /** */

  float spaceshipScale, timeScale;
  float scale[] = new float[14];
  CivLogData civLogData;
  
  final public static int TotalColor = 12;
  Color color[] = {Color.black, Color.blue, Color.cyan, Color.yellow,
                   Color.pink, Color.green, Color.orange, Color.magenta,
                   Color.lightGray, Color.red, Color.gray, Color.darkGray};

  int x2, y2;

  /** Creates new form CivLogDraw */
  public CivLogDraw (CivLogData data) {
    Debug.trace( "CivLogDraw.CivLogDraw(): initializing" );
    /** is the data a copy or point to the newer one */
    civLogData = data;
    initComponents ();
    setBackground (Color.white);
    startYear = -4000;
    endYear   = 2000;
    Debug.trace( "CivLogDraw.CivLogDraw(): done" );
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    setLayout (new java.awt.BorderLayout ());
    setPreferredSize (new java.awt.Dimension (500, 100));
    setBorder (new javax.swing.border.TitledBorder (""));
    setMinimumSize (new java.awt.Dimension (500, 100));

  }//GEN-END:initComponents

  public void paint (Graphics g) {

    super.paint(g);

    /** check if any data is loaded */
    if ( (civLogData.numofPlayers == 0) || (civLogData.civscore.isEmpty ())
         || (currentData == -1) || (civLogData.selectedPlayers.isEmpty()) ) {
      Debug.trace( "CivLogDraw.paint(): no permission or data empty" );
    }
    else {
      drawGraph(g);
    }
  
    return;
    
  }/* end - paint() */
  
  /**
     ***********************************************************
  *  drawGraph() - 
  *
  *
  *
  **************************************************************
                                                                */
  public void drawGraph (Graphics g) {
    
    Debug.trace( "CivLogDraw.drawGraph(): initializing");

    Dimension d = getSize ();
    /* draw the current lines */
    g.setColor (getForeground ());

    /** initalize data here */
    x2 = 0;
    y2 = 0;
    int value = 0;
    int index = 0;
    currentTurnRange = 0;
    
    Vector line = new Vector();
    
    for (int z=0; z < civLogData.selectedPlayers.size(); z++ ) {
      line.addElement ( new PolyLine() );
    }
    
    rescale (d);
    
    currentTurnRange = calculateFreeCivTurns ();
    
    timeScale = (float)(d.width / currentTurnRange);
    
    Debug.trace( "CivLogDraw.paint(): timescale: " + timeScale + " turnRange: "
                  + currentTurnRange);

    /** TODO: optimize here */
    for (int i=0; i < civLogData.civscore.size (); i++) {
      CivLogDataEntry current = (CivLogDataEntry)civLogData.civscore.elementAt (i);
      /** filter what to process */
      if ( (current.year > startYear) && (current.year < endYear)) {
        for (int j=0; j < civLogData.selectedPlayers.size (); j++) {
          Integer idx = (Integer)civLogData.selectedPlayers.elementAt (j);
          index = idx.intValue ();
          
          if ( current.player == index) {
            /** error checking?? */
            value = current.get_data (currentData); /** get selected data */
            y2 = Math.round ( d.height - (value*scale[currentData])); /** scale the value */
            PolyLine theLine = (PolyLine)line.elementAt(j);
            theLine.addPoint (x2, y2, value);

            theLine.currentX += timeScale; /** not redundant, for higher resolution scale */
            x2 = Math.round (theLine.currentX);
          }

          //Debug.trace("value: " + value);
        }/* end - for */
      }/* end- if */
    }/* end - for */

    /** Assign Players Names to the label */
    for (int j=0; j < civLogData.selectedPlayers.size (); j++) {
      Integer idx = (Integer)civLogData.selectedPlayers.elementAt (j);
      index = idx.intValue ();
      PolyLine theLine = (PolyLine)line.elementAt (j);
      theLine.setLabel ( (String)civLogData.playerNames.elementAt (index));
      theLine.setColor ( color[j%(TotalColor-1)]);
    }

    Font font = g.getFont ();
    font = font.deriveFont ( (float)9.0);
    g.setFont (font);

    for (int y=0; y < civLogData.selectedPlayers.size (); y++ ) {
      PolyLine theLine = (PolyLine)line.elementAt (y);

      if (civLogData.selectedPlayers.size () == 1) {
        theLine.drawAverage (g, d, scale[currentData]);
        theLine.drawPolyLine (g);
        theLine.drawLabel (g, d.height);
        theLine.drawMaxPoint (g);
        theLine.drawMinPoint (g);
      }
      /** draw only a few things if more than one graph */
      else {
        theLine.drawPolyLine (g);
        theLine.drawLabel (g, d.height);
        theLine.drawMaxPoint (g);
      }   
    }

    Debug.trace ( "CivLogDraw.drawGraph(): done");
  }/* end - drawGraph() */

  int calculateFreeCivTurns () {

    int turns = 0;

    /** this updated formula is the one giving me the bigest headache */
    /** add a +1 to this formula to be more accurate */
    /** this formula calculate the no. of turn between any two freeciv years (>= -4000) */
    /** -4000 <= x < -1000, 50 turns */
    turns =  Math.abs ( (Math.min (Math.max (startYear,-4000), -999)
    - Math.min (Math.max (endYear,  -4000), -999)) / 50);
    /** -1000 <= x < -1, 25 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear,-1000),   -1)
    - Math.min (Math.max (endYear,  -1000),   -1)) / 25);
    /** 0 <= x < 1000, 20 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear,    0),  999)
    - Math.min (Math.max (endYear,      0),  999)) / 20);
    /** 1000 <= x < 1500, 10 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear, 1000), 1499)
    - Math.min (Math.max (endYear,   1000), 1499)) / 10);
    /** 1500 <= x < 1750, 5 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear, 1500), 1749)
    - Math.min (Math.max (endYear,   1500), 1749)) / 5);
    /** 1750 <= x < 1900, 2 turns */
    turns += Math.abs ( (Math.min (Math.max (startYear, 1750), 1899)
    - Math.min (Math.max (endYear,   1750), 1899)) / 2);
    /** 1900 <= x, 1 turn */
    turns += Math.abs ( (Math.max (startYear, 1900) - Math.max (endYear, 1900)) / 1);

    return (turns+1);
  }

  void rescale (Dimension d) {

    /** scale factors */
    scale[Freeciv.POP]         = (float)d.height / (civLogData.maxPop + 10); /** Avg: 250 */
    scale[Freeciv.BNP]         = (float)d.height / (civLogData.maxBnp + 25); /** Avg: 550 */
    scale[Freeciv.MFG]         = (float)d.height / (civLogData.maxMfg + 12); /** Avg: 190 */
    scale[Freeciv.CITIES]      = (float)d.height / (civLogData.maxCities + 3); /** Avg: 60 */
    scale[Freeciv.TECHS]       = (float)d.height / (civLogData.maxTechs + 3); /** Avg: 40 */
    scale[Freeciv.MUNITS]      = (float)d.height / (civLogData.maxMunits + 4); /** Avg: 55 */
    scale[Freeciv.SETTLERS]    = (float)d.height / (civLogData.maxSettlers + 1); /** Avg: 12 */
    scale[Freeciv.WONDERS]     = (float)d.height / (civLogData.maxWonders + 1); /** Avg: 4 */
    scale[Freeciv.TECHOUT]     = (float)d.height / (civLogData.maxTechout + 18); /** Avg: 320 */
    scale[Freeciv.LANDAREA]    = (float)d.height / (civLogData.maxLandArea + 40000); /** Avg: 540000 */
    scale[Freeciv.SETTLEDAREA] = (float)d.height / (civLogData.maxSettledArea + 30000); /** Avg: 476000 */
    scale[Freeciv.POLLUTION]   = (float)d.height / (civLogData.maxPollution + 1); /** Avg: ? */
    scale[Freeciv.LITERACY]    = (float)d.height / (civLogData.maxLiteracy + 1); /** Avg: ? */
    scale[Freeciv.SPACESHIP]   = (float)d.height / (civLogData.maxSpaceship + 1); /** Avg: ? */

  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables

}
// end of CivLogDraw.java