#!/bin/sh


JAR_INSTALL_DIR=/usr/local/lib
JAR_FILE=CivLog.jar
JAVA_COMMAND=java
JAVA_OPTIONS="-jar"
MAIN_CLASS=""
REAL_MAIN_CLASS="CivLog"
OUTPUT_SCRIPT_NAME="CivLog"

SCRIPT_INSTALL_DIR=/usr/local/bin

# copy jar file to install dir
#
cp $JAR_FILE $JAR_INSTALL_DIR

if [ $? != 0 ]
then
	echo "Unable to copy $JAR_FILE to $JAR_INSTALL_DIR"
	exit 1
fi


buildScript()
{

	echo "#!/bin/sh"
	echo "" 
	echo "$JAVA_COMMAND $JAVA_OPTIONS $JAR_INSTALL_DIR/$JAR_FILE $MAIN_CLASS \$@"
}	


java=`which java`
if [ $? != 0 ]
then
	# try jre
	#
	java=`which jre`
fi

if [ $? = 0 ]
then
	JAVA_COMMAND=$java
fi


# build the script
#
if [ -x $JAVA_COMMAND ]
then
	# get the java version
	#
	$JAVA_COMMAND -version 2> /tmp/java_version

	version=`grep "1.1." /tmp/java_version` 

	if [ $? = 0 ] 
	then
		# this is java 1.1.x
		#
		JAVA_OPTIONS="-cp"
		MAIN_CLASS=$REAL_MAIN_CLASS
	fi

fi

# build the script
#

buildScript > $OUTPUT_SCRIPT_NAME

chmod +x $OUTPUT_SCRIPT_NAME

cp $OUTPUT_SCRIPT_NAME $SCRIPT_INSTALL_DIR





